#!/bin/bash
#
# This is a helper script that keeps SnapRAID parity info in sync with
# your data. Here's how it works:
#   1) It first calls diff to figure out if the parity info is out of sync
#   2) If there are changed files (i.e. new, changed, moved or removed),
#         it then checks how many files were removed.
#   3) If the deleted files exceed X (configurable), it triggers an
#         alert email and stops. (in case of accidental deletions)
#   4) Otherwise, it will call sync.
#   5) When sync finishes, it sends an email with the output to user.
#
# $1: <non empty value>: Run manually (don't check DEL_THRESHOLD)

_HOSTNAME=$(hostname -A | head -1)

# Bin paths
MKDIR=/bin/mkdir
CAT=/bin/cat
LOGGER=/usr/bin/logger
ECHO=/bin/echo
SNAPRAID=/usr/local/bin/snapraid
GREP=/bin/grep
SED=/bin/sed
CUT=/usr/bin/cut
MAIL=/usr/bin/mail
PUSHOVER=/usr/local/bin/pushover.sh

# Output variables
EMAIL_ADDRESS={{ notification.gmail.email }}
EMAIL_SUBJECT_PREFIX="[$_HOSTNAME] SnapRAID - "
PUSHOVER_USER_KEY={{ notification.pushover.user_key }}
PUSHOVER_APP_TOKEN={{ notification.pushover.roles[current_group_role].snapraid_token }}

# Possible values
#   * log
#   * pushover
#   * gmail
OUTPUT_METHOD="gmail"

# Misc variables
DEL_THRESHOLD=50
CONTENT_FILE="/home/{{ topology.roles[current_group_role].data.user.name }}/OS.snapraid_content"
PARITY_FILE="{{ topology.roles[current_group_role].data.paths.drives }}/PARITY_1/PARITY_1.snapraid_parity"
LOG_FILE="/home/{{ topology.roles[current_group_role].data.user.name }}/.snapraid/snapraid.log"

## INTERNAL TEMP VARS ##
TMP_OUTPUT="/tmp/snapraid_log.txt"


# $1: Subject
# $2: Content
_output() {
    case $OUTPUT_METHOD in
        gmail)
            $ECHO "$1" |
            $MAIL -s "$2" -a "$TMP_OUTPUT" "$EMAIL_ADDRESS"
            ;;
    
        pushover)
            $PUSHOVER -U $PUSHOVER_USER_KEY -T $PUSHOVER_APP_TOKEN -t "$1" "$2"
            ;;

        log)
            $LOGGER -t "$0" "$1: $2"
            ;;
    esac
}


# Redirect all stdout to log file (leave stderr alone though)
exec >> $LOG_FILE

# Timestamp the job
$ECHO "[`date`] SnapRAID Job started."
$ECHO "SnapRAID DIFF Job started on `date`" > $TMP_OUTPUT
$ECHO "----------------------------------------" >> $TMP_OUTPUT

#TODO - mount and unmount parity disk on demand!

# Sanity check first to make sure we can access the content and parity files
if [ ! -e $CONTENT_FILE ]; then
    $ECHO "[`date`] ERROR - Content file ($CONTENT_FILE) not found!"
    $ECHO "ERROR - Content file ($CONTENT_FILE) not found!" >> $TMP_OUTPUT

    _output "$EMAIL_SUBJECT_PREFIX ERROR - Content file not found!" \
            "ERROR - Content file ($CONTENT_FILE) not found!"

    exit 1;
fi

if [ ! -e $PARITY_FILE ]; then
    $ECHO "[`date`] ERROR - Parity file ($PARITY_FILE) not found!"
    $ECHO "ERROR - Parity file ($PARITY_FILE) not found!" >> $TMP_OUTPUT

    _output "$EMAIL_SUBJECT_PREFIX ERROR - Parity file not found!" \
            "ERROR - Parity file ($PARITY_FILE) not found!"

    exit 1;
fi

# Run the snapraid DIFF command
$ECHO "[`date`] Running DIFF Command."
$SNAPRAID diff >> $TMP_OUTPUT

$ECHO "----------------------------------------" >> $TMP_OUTPUT
$ECHO "SnapRAID DIFF Job finished on `date`" >> $TMP_OUTPUT

ADD_COUNT=$($GREP -w '^ \{1,\}[0-9]* added$' $TMP_OUTPUT | $SED 's/^ *//g' | $CUT -d ' ' -f1)
DEL_COUNT=$($GREP -w '^ \{1,\}[0-9]* removed$' $TMP_OUTPUT | $SED 's/^ *//g' | $CUT -d ' ' -f1)
MOVE_COUNT=$($GREP -w '^ \{1,\}[0-9]* moved$' $TMP_OUTPUT | $SED 's/^ *//g' | $CUT -d ' ' -f1)
COPY_COUNT=$($GREP -w '^ \{1,\}[0-9]* copied$' $TMP_OUTPUT | $SED 's/^ *//g' | $CUT -d ' ' -f1)
UPDATE_COUNT=$($GREP -w '^ \{1,\}[0-9]* updated$' $TMP_OUTPUT | $SED 's/^ *//g' | $CUT -d ' ' -f1)

$ECHO "SUMMARY of changes - Added [$ADD_COUNT] - Deleted [$DEL_COUNT] - Moved [$MOVE_COUNT] - Copied [$COPY_COUNT] - Updated [$UPDATE_COUNT]" >> $TMP_OUTPUT

if [ -z $ADD_COUNT ] && [ -z $DEL_COUNT ] && [ -z $MOVE_COUNT ] && [ -z $COPY_COUNT ] && [ -z $UPDATE_COUNT ]; then
    $ECHO "Couldn't fetch all the numbers, so exiting the script." >> $TMP_OUTPUT

    _output "$EMAIL_SUBJECT_PREFIX WARNING - Couldn't fetch all the numbers" \
            "Couldn't fetch all the numbers, so exiting the script."

    exit 0
else
    _output "$EMAIL_SUBJECT_PREFIX Diff Job COMPLETED" \
            "SUMMARY of changes - Added [$ADD_COUNT] - Deleted [$DEL_COUNT] - Moved [$MOVE_COUNT] - Copied [$COPY_COUNT] - Updated [$UPDATE_COUNT]"
fi

# Check if files have changed
if [ $DEL_COUNT -gt 0 -o $ADD_COUNT -gt 0 -o $MOVE_COUNT -gt 0 -o $UPDATE_COUNT -gt 0 ]; then
    # YES, check if number of deleted files exceed DEL_THRESHOLD
    if [ $DEL_COUNT -gt $DEL_THRESHOLD ] && [ -z $1  ]; then
        # YES, lets inform user and not proceed with the sync just in case
        $ECHO "Number of deleted files ($DEL_COUNT) exceeded threshold ($DEL_THRESHOLD). NOT proceeding with sync job. Please run sync manually if this is not an error condition." >> $TMP_OUTPUT

        _output "$EMAIL_SUBJECT_PREFIX WARNING - Number of deleted files exceeded threshold" \
                "Number of deleted files ($DEL_COUNT) exceeded threshold ($DEL_THRESHOLD). NOT proceeding with sync job. Please run sync manually if this is not an error condition."

        $ECHO "WARNING - Deleted files ($DEL_COUNT) exceeded threshold ($DEL_THRESHOLD). Check $TMP_OUTPUT for details. NOT proceeding with sync job."
    else
        # NO, delete threshold not reached, lets run the sync job
        if ! [ -z $1 ]; then
            $ECHO "Running manually, not checking the delete threshold." >> $TMP_OUTPUT
        fi

        $ECHO "Deleted files ($DEL_COUNT) did not exceed threshold ($DEL_THRESHOLD), proceeding with sync job." >> $TMP_OUTPUT
        $ECHO "[`date`] Changes detected [A-$ADD_COUNT,D-$DEL_COUNT,M-$MOVE_COUNT,U-$UPDATE_COUNT] and deleted files ($DEL_COUNT) is below threshold ($DEL_THRESHOLD). Running SYNC Command."
        $ECHO "SnapRAID SYNC Job started on `date`" >> $TMP_OUTPUT
        $ECHO "----------------------------------------" >> $TMP_OUTPUT

        $SNAPRAID sync --pre-hash >> $TMP_OUTPUT

        $ECHO "----------------------------------------" >> $TMP_OUTPUT
        $ECHO "SnapRAID SYNC Job finished on `date`" >> $TMP_OUTPUT

        _output "$EMAIL_SUBJECT_PREFIX Sync Job COMPLETED" \
                "Sync Job COMPLETED"
    fi
else
    # NO, so lets log it and exit
    $ECHO "[`date`] No change detected. Nothing to do."

    _output "$EMAIL_SUBJECT_PREFIX No change detected. Nothing to do." \
            "No change detected. Nothing to do."
fi

# Run "full" scrub on Sundays, otherwise only "new" scrub
if [ $(date +%u) -eq 7 ]; then
    $ECHO "Running SnapRAID full scrub. This will take a while" >> $TMP_OUTPUT

    $SNAPRAID scrub -p full >> $TMP_OUTPUT

    _output "$EMAIL_SUBJECT_PREFIX Full Scrub COMPLETED" \
            "Full Scrub COMPLETED"
else
    $ECHO "Running SnapRAID new scrub. This will take a while" >> $TMP_OUTPUT

    $SNAPRAID scrub -p new >> $TMP_OUTPUT

    _output "$EMAIL_SUBJECT_PREFIX New Scrub COMPLETED" \
            "New Scrub COMPLETED"
fi

$ECHO "[`date`] Job ended."

exit 0;
